// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Take the name prefix into account.
#define yylex   lhalex

// First part of user declarations.

#line 39 "Lha-parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "Lha-parser.hh"

// User implementation prologue.

#line 53 "Lha-parser.cc" // lalr1.cc:412
// Unqualified %code blocks.
#line 41 "Lha-parser.yy" // lalr1.cc:413

	#include "../HaslFormula.hpp"
	#include "Lha-Reader.hpp"
	#include <set>
	#include <vector>
	
	Eval LhaEvaluate;
	
	

	vector<string> FuncFlowVector;
	
	vector<string> FuncUpdateVector;
    vector<string> FuncUpdateVectorIndex;
	
	set <string> PetriTransitions;
	set <string> SubSet;
	
	
	
	vector < string > CoeffsVector;
	vector < vector <string> > CoeffsMatrix;
	vector <string> CST;
	vector <string> comp;
	
	
	
	
	
	

#line 87 "Lha-parser.cc" // lalr1.cc:413


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace lha {
#line 173 "Lha-parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Lha_parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Lha_parser::Lha_parser (Lha_Reader& Reader_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      Reader (Reader_yyarg)
  {}

  Lha_parser::~Lha_parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/

  inline
  Lha_parser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  Lha_parser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  Lha_parser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
    value = other.value;
  }


  template <typename Base>
  inline
  Lha_parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  inline
  Lha_parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  inline
  Lha_parser::basic_symbol<Base>::~basic_symbol ()
  {
    clear ();
  }

  template <typename Base>
  inline
  void
  Lha_parser::basic_symbol<Base>::clear ()
  {
    Base::clear ();
  }

  template <typename Base>
  inline
  bool
  Lha_parser::basic_symbol<Base>::empty () const
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  inline
  void
  Lha_parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
    value = s.value;
    location = s.location;
  }

  // by_type.
  inline
  Lha_parser::by_type::by_type ()
    : type (empty_symbol)
  {}

  inline
  Lha_parser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  Lha_parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  Lha_parser::by_type::clear ()
  {
    type = empty_symbol;
  }

  inline
  void
  Lha_parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  inline
  int
  Lha_parser::by_type::type_get () const
  {
    return type;
  }


  // by_state.
  inline
  Lha_parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  Lha_parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  Lha_parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  Lha_parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  Lha_parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  Lha_parser::symbol_number_type
  Lha_parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  Lha_parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  Lha_parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
    value = that.value;
    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  Lha_parser::stack_symbol_type&
  Lha_parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  Lha_parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    switch (yysym.type_get ())
    {
            case 3: // str

#line 169 "Lha-parser.yy" // lalr1.cc:617
        { delete (yysym.value.name); }
#line 426 "Lha-parser.cc" // lalr1.cc:617
        break;


      default:
        break;
    }
  }

#if YYDEBUG
  template <typename Base>
  void
  Lha_parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    switch (yytype)
    {
            case 3: // str

#line 168 "Lha-parser.yy" // lalr1.cc:636
        { debug_stream () << *(yysym.value.name); }
#line 457 "Lha-parser.cc" // lalr1.cc:636
        break;

      case 4: // rval

#line 172 "Lha-parser.yy" // lalr1.cc:636
        { debug_stream () << (yysym.value.RealVal); }
#line 464 "Lha-parser.cc" // lalr1.cc:636
        break;

      case 5: // ival

#line 171 "Lha-parser.yy" // lalr1.cc:636
        { debug_stream () << (yysym.value.IntVal); }
#line 471 "Lha-parser.cc" // lalr1.cc:636
        break;

      case 110: // rorival

#line 172 "Lha-parser.yy" // lalr1.cc:636
        { debug_stream () << (yysym.value.RealVal); }
#line 478 "Lha-parser.cc" // lalr1.cc:636
        break;


      default:
        break;
    }
    yyo << ')';
  }
#endif

  inline
  void
  Lha_parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  Lha_parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  Lha_parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Lha_parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Lha_parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Lha_parser::debug_level_type
  Lha_parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Lha_parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline Lha_parser::state_type
  Lha_parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  Lha_parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Lha_parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Lha_parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, Reader));
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 3:
#line 189 "Lha-parser.yy" // lalr1.cc:859
    {Reader.MyLha.isDeterministic=false;}
#line 698 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 9:
#line 201 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%i",(yystack_[0].value.IntVal));}
#line 704 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 202 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.PlaceIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.PlaceIndex.end())
	{std::ostringstream s; s<<" Marking.P->_PL_"<< (yystack_[0].value.name)->c_str()<<" ";
		sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
	}
	else if(Reader.MyLha.LhaIntConstant.find(*(yystack_[0].value.name))!=Reader.MyLha.LhaIntConstant.end())
	{std::ostringstream s; s<<Reader.MyLha.LhaIntConstant[*(yystack_[0].value.name)];
		sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
	} else {
        size_t vararray = Reader.MyLha.Vars.find(*(yystack_[0].value.name));
        if(vararray!= Reader.MyLha.NbVar && Reader.MyLha.Vars.type[vararray]==DISCRETE_VARIABLE){
            sprintf((yylhs.value.expression), " floor(Vars->%s)", Reader.MyLha.Vars.label[vararray].c_str() );
        } else {cout<<"'"<<*(yystack_[0].value.name)<<"' is not a place label or a defined constant"<<endl;YYABORT;}
    }
}
#line 724 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 11:
#line 217 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.PlaceIndex.find(*(yystack_[3].value.name))!=Reader.MyLha.PlaceIndex.end())
	{std::ostringstream s;
	 s<<" Marking.P->_PL_"<< (yystack_[3].value.name)->c_str()<< ".mult";
	 s << (yystack_[1].value.expression);
		sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
	}else{cout<<"'"<<*(yystack_[3].value.name)<<"' is not a place label "<<endl;YYABORT;}}
#line 736 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 224 "Lha-parser.yy" // lalr1.cc:859
    {
    size_t vararray = Reader.MyLha.Vars.find(*(yystack_[3].value.name));
	if(vararray!= Reader.MyLha.NbVar && Reader.MyLha.Vars.type[vararray]==INT_INDEXED_DISC_ARRAY)
	{std::ostringstream s;
        s<<" Vars.P->" << Reader.MyLha.Vars.label[vararray] << "["<< *(yystack_[1].value.expression) << "]";
		sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
	}else{cout<<"'"<<*(yystack_[3].value.name)<<"' is not a discrete array name "<<endl;YYABORT;}}
#line 748 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 13:
#line 231 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"( %s )", (yystack_[1].value.expression));       }
#line 754 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 232 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"-%s",(yystack_[0].value.expression));}
#line 760 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 15:
#line 233 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s + %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 766 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 234 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s - %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 772 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 17:
#line 235 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s * %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 778 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 236 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"pow(%s , %s)", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 784 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 19:
#line 237 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"floor( %s )", (yystack_[1].value.expression));  }
#line 790 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 238 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"floor( %s /double(%s))", (yystack_[3].value.expression),(yystack_[1].value.expression));  }
#line 796 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 21:
#line 239 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"min(%s , %s)", (yystack_[3].value.expression), (yystack_[1].value.expression));  }
#line 802 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 240 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"max(%s , %s)", (yystack_[3].value.expression), (yystack_[1].value.expression));  }
#line 808 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 23:
#line 241 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"((int)%s %% (int)%s)", (yystack_[3].value.expression), (yystack_[1].value.expression));  }
#line 814 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 244 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression), "%f",(yystack_[0].value.RealVal));}
#line 820 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 25:
#line 245 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%d",(yystack_[0].value.IntVal));}
#line 826 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 246 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.PlaceIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.PlaceIndex.end())
	{std::ostringstream s; s<<" Marking.P->_PL_"<<(yystack_[0].value.name)->c_str();
		if(Reader.MyLha.MyGspn->placeStruct[Reader.MyLha.PlaceIndex[*(yystack_[0].value.name)]].colorDom !=0 )s <<".card()";
		sprintf((yylhs.value.expression), "%s ",(s.str()).c_str());
	}
	else if(Reader.MyLha.LhaRealConstant.find(*(yystack_[0].value.name))!=Reader.MyLha.LhaRealConstant.end())
	{std::ostringstream s; s<<Reader.MyLha.LhaRealConstant[*(yystack_[0].value.name)];
		sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
	}
	
	else{cout<<"'"<<*(yystack_[0].value.name)<<"' is not a place label or a defined constant"<<endl;YYABORT;}}
#line 843 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 258 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.PlaceIndex.find(*(yystack_[3].value.name))!=Reader.MyLha.PlaceIndex.end())
	{std::ostringstream s;
	 s<<" Marking.P->_PL_"<< (yystack_[3].value.name)->c_str()<< ".mult";
	 s << (yystack_[1].value.expression);
		sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
	}else{cout<<"'"<<*(yystack_[3].value.name)<<"' is not a place label "<<endl;YYABORT;}}
#line 855 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 265 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"( %s )", (yystack_[1].value.expression));       }
#line 861 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 266 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"-%s",(yystack_[0].value.expression));}
#line 867 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 267 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s /double(%s)", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 873 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 268 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s + %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 879 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 269 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s - %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 885 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 270 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s * %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 891 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 271 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"pow(%s , %s)", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 897 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 35:
#line 272 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"floor( %s )", (yystack_[1].value.expression));  }
#line 903 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 36:
#line 273 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"min(%s , %s)", (yystack_[3].value.expression), (yystack_[1].value.expression));  }
#line 909 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 37:
#line 274 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"max(%s , %s)", (yystack_[3].value.expression), (yystack_[1].value.expression));  }
#line 915 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 38:
#line 276 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression), "%f",(yystack_[0].value.RealVal));}
#line 921 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 277 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%d",(yystack_[0].value.IntVal));}
#line 927 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 278 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.PlaceIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.PlaceIndex.end())
	{std::ostringstream s; s<<" Marking.P->_PL_"<<(yystack_[0].value.name)->c_str();
		if(Reader.MyLha.MyGspn->placeStruct[Reader.MyLha.PlaceIndex[*(yystack_[0].value.name)]].colorDom !=0 )s <<".card()";
		sprintf((yylhs.value.expression), "%s ",(s.str()).c_str());
	}
	else{ if(Reader.MyLha.LhaRealConstant.find(*(yystack_[0].value.name))!=Reader.MyLha.LhaRealConstant.end())
		{std::ostringstream s; s<<Reader.MyLha.LhaRealConstant[*(yystack_[0].value.name)];
			sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
		}
		else {if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
			{
				std::ostringstream s; s<<"Vars->"<< (yystack_[0].value.name)->c_str();
				sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
			}
			else {cout<<"'"<<*(yystack_[0].value.name)<<"' is not a place label, a lha variable or a defined constant"<<endl;YYABORT;}
		}
	}
}
#line 951 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 41:
#line 297 "Lha-parser.yy" // lalr1.cc:859
    {
    size_t varin = Reader.MyLha.Vars.find(*(yystack_[3].value.name));
    if(varin != Reader.MyLha.Vars.label.size()){
        sprintf((yylhs.value.expression), "Vars->%s[%s]", (yystack_[3].value.name)->c_str(),(yystack_[1].value.expression));
    }
        else {cout<<"'"<<*(yystack_[3].value.name)<<"' is not an lha array variable"<<endl;YYABORT;}
    }
#line 963 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 42:
#line 304 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.PlaceIndex.find(*(yystack_[3].value.name))!=Reader.MyLha.PlaceIndex.end())
	{std::ostringstream s;
	 s<<" Marking.P->_PL_"<< (yystack_[3].value.name)->c_str()<< ".mult";
	 s << (yystack_[1].value.expression);
		sprintf((yylhs.value.expression), "%s",(s.str()).c_str());
	}else{cout<<"'"<<*(yystack_[3].value.name)<<"' is not a place label "<<endl;YYABORT;}}
#line 975 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 43:
#line 311 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"( %s )", (yystack_[1].value.expression));       }
#line 981 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 44:
#line 312 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"-%s",(yystack_[0].value.expression));}
#line 987 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 313 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s /double(%s)", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 993 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 314 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s + %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 999 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 47:
#line 315 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s - %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 1005 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 48:
#line 316 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s * %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 1011 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 49:
#line 317 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"pow(%s , %s)", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 1017 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 50:
#line 318 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"floor( %s )", (yystack_[1].value.expression));  }
#line 1023 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 319 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"min(%s , %s)", (yystack_[3].value.expression), (yystack_[1].value.expression));  }
#line 1029 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 320 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"max(%s , %s)", (yystack_[3].value.expression), (yystack_[1].value.expression));  }
#line 1035 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 322 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"[%s]", (yystack_[1].value.name)->c_str()); }
#line 1041 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 54:
#line 323 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"[%s]%s", (yystack_[2].value.name)->c_str(), (yystack_[0].value.expression)); }
#line 1047 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 57:
#line 327 "Lha-parser.yy" // lalr1.cc:859
    {Reader.MyLha.NbVar=0;}
#line 1053 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 58:
#line 328 "Lha-parser.yy" // lalr1.cc:859
    {Reader.MyLha.NbLoc=0;}
#line 1059 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 59:
#line 329 "Lha-parser.yy" // lalr1.cc:859
    {Reader.MyLha.NbVar=0;Reader.MyLha.NbLoc=0;}
#line 1065 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 62:
#line 335 "Lha-parser.yy" // lalr1.cc:859
    {if(Reader.MyLha.LhaRealConstant.find(*(yystack_[3].value.name))!=Reader.MyLha.LhaRealConstant.end())
	{cout<<"Constant "<<*(yystack_[3].value.name)<<" already defined."<<endl; YYABORT;}
	else {string st=(yystack_[1].value.expression);
		if (Reader.P.constants.count(*(yystack_[3].value.name))>0)st = Reader.P.constants[*(yystack_[3].value.name)];
		
		LhaEvaluate.parse(st);
		Reader.MyLha.LhaIntConstant[*(yystack_[3].value.name)]=LhaEvaluate.IntResult;Reader.MyLha.LhaRealConstant[*(yystack_[3].value.name)]=LhaEvaluate.RealResult;}
}
#line 1078 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 63:
#line 344 "Lha-parser.yy" // lalr1.cc:859
    {if(Reader.MyLha.LhaRealConstant.find(*(yystack_[3].value.name))!=Reader.MyLha.LhaRealConstant.end())
	{cout<<"Constant "<<*(yystack_[3].value.name)<<" already defined."<<endl; YYABORT;}
	else {string st=(yystack_[1].value.expression);
		if (Reader.P.constants.count(*(yystack_[3].value.name))>0)st = Reader.P.constants[*(yystack_[3].value.name)];
		LhaEvaluate.parse(st);
		Reader.MyLha.LhaRealConstant[*(yystack_[3].value.name)]=LhaEvaluate.RealResult;}
}
#line 1090 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 354 "Lha-parser.yy" // lalr1.cc:859
    {Reader.MyLha.NbVar=(yystack_[1].value.IntVal);}
#line 1096 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 356 "Lha-parser.yy" // lalr1.cc:859
    {Reader.MyLha.NbLoc=(yystack_[1].value.IntVal);}
#line 1102 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 68:
#line 361 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.NbVar==0)Reader.MyLha.NbVar = Reader.MyLha.Vars.label.size();
	if(Reader.MyLha.Vars.label.size()!=Reader.MyLha.NbVar){
		std::cout<<"Variable label missing or redeclared, please check your variables list"<<std::endl;
		YYABORT;
	}

	FuncFlowVector.resize(Reader.MyLha.NbVar);
	FuncUpdateVector.resize(Reader.MyLha.NbVar);
    FuncUpdateVectorIndex.resize(Reader.MyLha.NbVar);
	CoeffsVector.resize(Reader.MyLha.NbVar);

	for(const auto &it : Reader.MyLha.TransitionIndex)
		PetriTransitions.insert(it.first);
}
#line 1122 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 69:
#line 377 "Lha-parser.yy" // lalr1.cc:859
    {
	Reader.MyLha.Vars.label.push_back(*(yystack_[0].value.name));
	Reader.MyLha.Vars.initialValue.push_back(0.0);
	Reader.MyLha.Vars.type.push_back(CONTINIOUS_VARIABLE);
	Reader.MyLha.Vars.colorDomain.push_back(UNCOLORED_DOMAIN);
    Reader.MyLha.Vars.isTraced.push_back(true);
	//Reader.MyLha.VarIndex[*$1]=Reader.MyLha.VarLabel.size()-1;
}
#line 1135 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 70:
#line 385 "Lha-parser.yy" // lalr1.cc:859
    {
	
	Reader.MyLha.Vars.label.push_back(*(yystack_[0].value.name));
	Reader.MyLha.Vars.initialValue.push_back(0.0);
	Reader.MyLha.Vars.type.push_back(DISCRETE_VARIABLE);
	Reader.MyLha.Vars.colorDomain.push_back(UNCOLORED_DOMAIN);
    Reader.MyLha.Vars.isTraced.push_back(true);
    //Reader.MyLha.VarIndex[*$1]=Reader.MyLha.VarLabel.size()-1;
	
}
#line 1150 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 71:
#line 395 "Lha-parser.yy" // lalr1.cc:859
    {

	Reader.MyLha.Vars.label.push_back(*(yystack_[3].value.name));
	Reader.MyLha.Vars.initialValue.push_back(0.0);
	Reader.MyLha.Vars.type.push_back(INT_INDEXED_DISC_ARRAY);
	Reader.MyLha.Vars.colorDomain.push_back((yystack_[1].value.IntVal));
    Reader.MyLha.Vars.isTraced.push_back(true);
	//Reader.MyLha.VarIndex[*$1]=Reader.MyLha.VarLabel.size()-1;

}
#line 1165 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 72:
#line 406 "Lha-parser.yy" // lalr1.cc:859
    {
	Reader.MyLha.Vars.label.push_back(*(yystack_[0].value.name));
	Reader.MyLha.Vars.initialValue.push_back(0.0);
	Reader.MyLha.Vars.type.push_back(CONTINIOUS_VARIABLE);
	Reader.MyLha.Vars.colorDomain.push_back(UNCOLORED_DOMAIN);
    Reader.MyLha.Vars.isTraced.push_back(true);
	//Reader.MyLha.VarIndex[*$3]=Reader.MyLha.VarLabel.size()-1;
}
#line 1178 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 73:
#line 414 "Lha-parser.yy" // lalr1.cc:859
    {
	Reader.MyLha.Vars.label.push_back(*(yystack_[0].value.name));
	Reader.MyLha.Vars.initialValue.push_back(0.0);
	Reader.MyLha.Vars.type.push_back(DISCRETE_VARIABLE);
	Reader.MyLha.Vars.colorDomain.push_back(UNCOLORED_DOMAIN);
    Reader.MyLha.Vars.isTraced.push_back(true);
	//Reader.MyLha.VarIndex[*$3]=Reader.MyLha.VarLabel.size()-1;
}
#line 1191 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 74:
#line 422 "Lha-parser.yy" // lalr1.cc:859
    {
    Reader.MyLha.Vars.label.push_back(*(yystack_[3].value.name));
	Reader.MyLha.Vars.initialValue.push_back(0.0);
	Reader.MyLha.Vars.type.push_back(INT_INDEXED_DISC_ARRAY);
	Reader.MyLha.Vars.colorDomain.push_back((yystack_[1].value.IntVal));
    Reader.MyLha.Vars.isTraced.push_back(true);

}
#line 1204 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 75:
#line 431 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.NbLoc ==0)Reader.MyLha.NbLoc = Reader.MyLha.LocIndex.size();
	if(Reader.MyLha.LocIndex.size()!=Reader.MyLha.NbLoc){
	std::cout<<"Location label missing or redeclared, please check your locations list"<<std::endl;
	YYABORT;
	}
    Reader.MyLha.FuncLocProperty=vector<string>(Reader.MyLha.NbLoc,"");
    Reader.MyLha.FuncFlow=vector<vector<string> >(Reader.MyLha.NbLoc,vector<string>(Reader.MyLha.NbVar,""));
}
#line 1218 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 76:
#line 441 "Lha-parser.yy" // lalr1.cc:859
    {
	Reader.MyLha.LocLabel.push_back(*(yystack_[0].value.name));
	Reader.MyLha.LocIndex[*(yystack_[0].value.name)]=Reader.MyLha.LocLabel.size()-1;
}
#line 1227 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 77:
#line 445 "Lha-parser.yy" // lalr1.cc:859
    {Reader.MyLha.LocLabel.push_back(*(yystack_[0].value.name));
	Reader.MyLha.LocIndex[*(yystack_[0].value.name)]=Reader.MyLha.LocLabel.size()-1;
}
#line 1235 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 81:
#line 455 "Lha-parser.yy" // lalr1.cc:859
    {
	
	if(Reader.MyLha.LocIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.LocIndex.end())
	Reader.MyLha.InitLoc.insert(Reader.MyLha.LocIndex[*(yystack_[0].value.name)]);
	else cout<<"Unknown location:" << *(yystack_[0].value.name) <<endl;
	
	
}
#line 1248 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 82:
#line 463 "Lha-parser.yy" // lalr1.cc:859
    {if(Reader.MyLha.LocIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.LocIndex.end())
	Reader.MyLha.InitLoc.insert(Reader.MyLha.LocIndex[*(yystack_[0].value.name)]);
	else cout<<"Unknown location:"<< *(yystack_[0].value.name) << endl;
}
#line 1257 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 84:
#line 470 "Lha-parser.yy" // lalr1.cc:859
    {
	
	if(Reader.MyLha.LocIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.LocIndex.end())
	Reader.MyLha.FinalLoc.insert(Reader.MyLha.LocIndex[*(yystack_[0].value.name)]);
	else cout<<"Unknown location: "<< *(yystack_[0].value.name) <<endl;
	
	
}
#line 1270 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 85:
#line 478 "Lha-parser.yy" // lalr1.cc:859
    {if(Reader.MyLha.LocIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.LocIndex.end())
	Reader.MyLha.FinalLoc.insert(Reader.MyLha.LocIndex[*(yystack_[0].value.name)]);
	else {cout<<"Unknown location: "<< *(yystack_[0].value.name) <<endl;YYABORT;}
}
#line 1279 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 88:
#line 492 "Lha-parser.yy" // lalr1.cc:859
    {
	for(size_t l=0; l<Reader.MyLha.FuncLocProperty.size();l++)
	if(Reader.MyLha.FuncLocProperty[l]=="")
	{cout<<"Some locations are not definded. Please define all the declared locations."<<endl;
		YYABORT;}
	
	Reader.MyLha.Out_S_Edges.resize(Reader.MyLha.NbLoc);
	Reader.MyLha.Out_A_Edges.resize(Reader.MyLha.NbLoc);
}
#line 1293 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 91:
#line 506 "Lha-parser.yy" // lalr1.cc:859
    {
    auto loc = Reader.MyLha.LocIndex.find(*(yystack_[8].value.name));
	if(loc !=Reader.MyLha.LocIndex.end()){
		Reader.MyLha.FuncLocProperty[loc->second]= (yystack_[6].value.expression);
		Reader.MyLha.FuncFlow[loc->second] = FuncFlowVector;
        FuncFlowVector=vector<string>(Reader.MyLha.NbVar,"");
	}
	else {cout<<"Unknown location: "<< *(yystack_[8].value.name) <<endl;YYABORT;}
	
}
#line 1308 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 519 "Lha-parser.yy" // lalr1.cc:859
    {
    auto loc = Reader.MyLha.LocIndex.find(*(yystack_[4].value.name));
	if(loc != Reader.MyLha.LocIndex.end()){
		Reader.MyLha.FuncLocProperty[loc->second]= (yystack_[2].value.expression);
		Reader.MyLha.FuncFlow[loc->second] = FuncFlowVector;
	}
	else {cout<<"Unknown location: "<< *(yystack_[4].value.name) <<endl;YYABORT;}
	
	
}
#line 1323 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 532 "Lha-parser.yy" // lalr1.cc:859
    {
    if(Reader.MyLha.Vars.find(*(yystack_[2].value.name))!=Reader.MyLha.Vars.label.size())
	FuncFlowVector[Reader.MyLha.Vars.find(*(yystack_[2].value.name))]=(yystack_[0].value.expression);
	else{ cout<<"'"<<*(yystack_[2].value.name)<<"' is not an Lha variable"<<endl;
		YYABORT;}
}
#line 1334 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 539 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"true");}
#line 1340 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 97:
#line 540 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"false");}
#line 1346 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 98:
#line 541 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s", (yystack_[0].value.expression));}
#line 1352 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 99:
#line 542 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s && %s", (yystack_[2].value.expression), (yystack_[0].value.expression));}
#line 1358 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 100:
#line 543 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s || %s", (yystack_[2].value.expression), (yystack_[0].value.expression));}
#line 1364 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 101:
#line 544 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"( %s )", (yystack_[1].value.expression));}
#line 1370 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 102:
#line 545 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"! %s", (yystack_[0].value.expression));}
#line 1376 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 103:
#line 547 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s == %s", (yystack_[2].value.expression), (yystack_[0].value.expression));}
#line 1382 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 104:
#line 548 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s <= %s", (yystack_[2].value.expression), (yystack_[0].value.expression));}
#line 1388 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 549 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s >= %s", (yystack_[2].value.expression), (yystack_[0].value.expression));}
#line 1394 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 550 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s < %s", (yystack_[2].value.expression), (yystack_[0].value.expression));}
#line 1400 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 107:
#line 551 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s > %s", (yystack_[2].value.expression), (yystack_[0].value.expression));}
#line 1406 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 108:
#line 556 "Lha-parser.yy" // lalr1.cc:859
    {
	
}
#line 1414 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 111:
#line 563 "Lha-parser.yy" // lalr1.cc:859
    {
	
	if(Reader.MyLha.LocIndex.find(*(yystack_[11].value.name))!=Reader.MyLha.LocIndex.end())
	if(Reader.MyLha.LocIndex.find(*(yystack_[9].value.name))!=Reader.MyLha.LocIndex.end())
	{ int ne=Reader.MyLha.Edge.size();
		Reader.MyLha.AnEdge.Index=ne;
		Reader.MyLha.AnEdge.Source=Reader.MyLha.LocIndex[*(yystack_[11].value.name)];
		Reader.MyLha.AnEdge.Target=Reader.MyLha.LocIndex[*(yystack_[9].value.name)];
		Reader.MyLha.Edge.push_back(Reader.MyLha.AnEdge);
		Reader.MyLha.EdgeActions.push_back(SubSet);
		if(SubSet.size()>0) Reader.MyLha.Out_S_Edges[Reader.MyLha.AnEdge.Source].insert(ne);
		else Reader.MyLha.Out_A_Edges[Reader.MyLha.AnEdge.Source].insert(ne);
		SubSet.erase(SubSet.begin(),SubSet.end());
		Reader.MyLha.ConstraintsCoeffs.push_back(CoeffsMatrix);
        Reader.MyLha.ConstraintsConstants.push_back(CST);
		Reader.MyLha.ConstraintsRelOp.push_back(comp);
		Reader.MyLha.unTimeEdgeConstraints.push_back("true");
		vector<string> vs;comp=vs;CST=vs;
		vector <vector <string> > ms;CoeffsMatrix=ms;
		
	}
	else {cout<<*(yystack_[9].value.name)<<" is not a location label"<<endl;YYABORT;}
	else  {cout<<*(yystack_[11].value.name)<<" is not a location label"<<endl;YYABORT;}
}
#line 1443 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 113:
#line 589 "Lha-parser.yy" // lalr1.cc:859
    {SubSet=PetriTransitions;}
#line 1449 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 114:
#line 590 "Lha-parser.yy" // lalr1.cc:859
    {set<string> temp=PetriTransitions;
	for(set<string>::iterator it=SubSet.begin();it!=SubSet.end();it++)
	temp.erase((*it));
	SubSet=temp;}
#line 1458 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 117:
#line 598 "Lha-parser.yy" // lalr1.cc:859
    {if(Reader.MyLha.TransitionIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.TransitionIndex.end())
	SubSet.insert(*(yystack_[0].value.name));
	else {cout<<*(yystack_[0].value.name)<<" is not a Petri-net transition "<<endl;YYABORT;}
}
#line 1467 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 118:
#line 602 "Lha-parser.yy" // lalr1.cc:859
    {if(Reader.MyLha.TransitionIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.TransitionIndex.end())
	SubSet.insert(*(yystack_[0].value.name));
	else {cout<<*(yystack_[0].value.name)<<" is not a Petri-net transition "<<endl;YYABORT;}}
#line 1475 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 119:
#line 607 "Lha-parser.yy" // lalr1.cc:859
    {}
#line 1481 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 120:
#line 608 "Lha-parser.yy" // lalr1.cc:859
    {}
#line 1487 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 122:
#line 612 "Lha-parser.yy" // lalr1.cc:859
    {CoeffsMatrix.push_back(CoeffsVector);
	comp.push_back("==");
	CST.push_back((yystack_[0].value.expression));
	vector<string> vs(Reader.MyLha.NbVar,"");CoeffsVector=vs;}
#line 1496 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 123:
#line 617 "Lha-parser.yy" // lalr1.cc:859
    {CoeffsMatrix.push_back(CoeffsVector);
	comp.push_back("<=");
	CST.push_back((yystack_[0].value.expression));
	vector<string> vs(Reader.MyLha.NbVar,"");CoeffsVector=vs;}
#line 1505 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 124:
#line 622 "Lha-parser.yy" // lalr1.cc:859
    {CoeffsMatrix.push_back(CoeffsVector);
	comp.push_back(">=");
	CST.push_back((yystack_[0].value.expression));
	vector<string> vs(Reader.MyLha.NbVar,"");CoeffsVector=vs;}
#line 1514 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 128:
#line 632 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]="1";}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 1522 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 129:
#line 636 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{std::ostringstream s; s<<"("<<(yystack_[3].value.expression)<<")";
		CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 1531 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 130:
#line 641 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{std::ostringstream s; s<<(yystack_[2].value.IntVal);
		CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 1540 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 131:
#line 646 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{std::ostringstream s; s<<(yystack_[2].value.RealVal);
		CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 1549 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 132:
#line 651 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{if(Reader.MyLha.LhaRealConstant.find(*(yystack_[2].value.name))!=Reader.MyLha.LhaRealConstant.end())
		{std::ostringstream s; s<<Reader.MyLha.LhaRealConstant[*(yystack_[2].value.name)];
			CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();
		}
		else
		{
			if(Reader.MyLha.PlaceIndex.find(*(yystack_[2].value.name))!=Reader.MyLha.PlaceIndex.end())
			{std::ostringstream s; s<<"Marking.P->_PL_"<<(yystack_[2].value.name)->c_str()<<" ";
				CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();
			}
			else
			{
				cout<<*(yystack_[2].value.name)<<" is not Petri-net Place or a defined constant "<<endl;
				YYABORT;
			}
		}
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}
}
#line 1574 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 133:
#line 672 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]="-1";}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 1582 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 134:
#line 676 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{std::ostringstream s; s<<"-("<<(yystack_[3].value.expression)<<")";
		CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 1591 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 135:
#line 681 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{std::ostringstream s; s<<"-"<<(yystack_[2].value.IntVal);
		CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 1600 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 136:
#line 686 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{std::ostringstream s; s<<"-"<<(yystack_[2].value.RealVal);
		CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 1609 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 137:
#line 691 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{if(Reader.MyLha.LhaRealConstant.find(*(yystack_[2].value.name))!=Reader.MyLha.LhaRealConstant.end())
		{std::ostringstream s; s<<"-"<<Reader.MyLha.LhaRealConstant[*(yystack_[2].value.name)];
			CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();
		}
		else
		{
			if(Reader.MyLha.PlaceIndex.find(*(yystack_[2].value.name))!=Reader.MyLha.PlaceIndex.end())
			{std::ostringstream s; s<<"-Marking.P->_PL_"<<(yystack_[2].value.name)->c_str()<<" ";
				CoeffsVector[Reader.MyLha.Vars.find(*(yystack_[0].value.name))]=s.str();
			}
			else
			{
				cout<<*(yystack_[2].value.name)<<" is not Petri-net Place or a defined constant "<<endl;
				YYABORT;
			}
		}
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}
}
#line 1634 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 138:
#line 713 "Lha-parser.yy" // lalr1.cc:859
    {
    Reader.MyLha.FuncEdgeUpdates.push_back(FuncUpdateVector);
    Reader.MyLha.FuncEdgeUpdatesIndex.push_back(FuncUpdateVectorIndex);
    FuncUpdateVector=vector<string>(Reader.MyLha.NbVar,"");
    FuncUpdateVectorIndex=vector<string>(Reader.MyLha.NbVar,"");
}
#line 1645 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 139:
#line 719 "Lha-parser.yy" // lalr1.cc:859
    {
    Reader.MyLha.FuncEdgeUpdates.push_back(FuncUpdateVector);
    Reader.MyLha.FuncEdgeUpdatesIndex.push_back(FuncUpdateVectorIndex);
}
#line 1654 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 142:
#line 727 "Lha-parser.yy" // lalr1.cc:859
    {
	if(Reader.MyLha.Vars.find(*(yystack_[2].value.name))!=Reader.MyLha.Vars.label.size())
    {FuncUpdateVector[Reader.MyLha.Vars.find(*(yystack_[2].value.name))]= (yystack_[0].value.expression);}
	else{cout<<*(yystack_[2].value.name)<<" is not  variable label"<<endl;YYABORT;}
}
#line 1664 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 143:
#line 732 "Lha-parser.yy" // lalr1.cc:859
    {
    size_t varin = Reader.MyLha.Vars.find(*(yystack_[5].value.name));
	if(varin != Reader.MyLha.Vars.label.size()){
        FuncUpdateVector[varin]= (yystack_[0].value.expression);
        FuncUpdateVectorIndex[varin]= (yystack_[3].value.expression);
        //cout << "var:" << *$1 << "\tindex:" << $3 << "\tupdate:" << $6<< endl;
    }else{cout<<*(yystack_[5].value.name)<<" is not  variable label"<<endl;YYABORT;}
}
#line 1677 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 146:
#line 746 "Lha-parser.yy" // lalr1.cc:859
    {
	if((yystack_[1].value.TOPHASL) != NULL){
		Reader.MyLha.HASLname.push_back(*(yystack_[3].value.name));
		Reader.MyLha.HASLtop.push_back((yystack_[1].value.TOPHASL));
	}else{
		for(vector<string>::iterator it = Reader.MyLha.HASLname.begin(); it <Reader.MyLha.HASLname.end() ; it++){
			if( it->find("$_$") == 0)
				it->replace(0,3,*(yystack_[3].value.name));
		}
	}
}
#line 1693 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 147:
#line 757 "Lha-parser.yy" // lalr1.cc:859
    {
	if((yystack_[1].value.TOPHASL) != NULL){
		Reader.MyLha.HASLname.push_back("");
		Reader.MyLha.HASLtop.push_back((yystack_[1].value.TOPHASL));
	}else{
		for(vector<string>::iterator it = Reader.MyLha.HASLname.begin(); it <Reader.MyLha.HASLname.end() ; it++){
			if( it->find("$_$") == 0)
				it->replace(0,3,"");
		}
	}
}
#line 1709 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 148:
#line 770 "Lha-parser.yy" // lalr1.cc:859
    {(yylhs.value.RealVal)=(yystack_[0].value.RealVal);}
#line 1715 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 149:
#line 771 "Lha-parser.yy" // lalr1.cc:859
    {(yylhs.value.RealVal)=(double)(yystack_[0].value.IntVal);}
#line 1721 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 150:
#line 772 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.LhaRealConstant.find(*(yystack_[0].value.name))!=Reader.MyLha.LhaRealConstant.end())
			(yylhs.value.RealVal) = Reader.MyLha.LhaRealConstant[*(yystack_[0].value.name)];
		else { if(Reader.MyLha.LhaIntConstant.find(*(yystack_[0].value.name))!=Reader.MyLha.LhaIntConstant.end())
			(yylhs.value.RealVal) = (double)Reader.MyLha.LhaIntConstant[*(yystack_[0].value.name)];
		else {
			cout<<*(yystack_[0].value.name)<<" is not a definded constant "<<endl;
			YYABORT;
		}}}
#line 1734 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 151:
#line 782 "Lha-parser.yy" // lalr1.cc:859
    {
	Reader.MyLha.Algebraic.push_back((yystack_[1].value.expression));
	(yylhs.value.TOPHASL) = new HaslFormulasTop((size_t)Reader.MyLha.Algebraic.size()-1);
}
#line 1743 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 152:
#line 786 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = new HaslFormulasTop(PROBABILITY);
}
#line 1751 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 153:
#line 789 "Lha-parser.yy" // lalr1.cc:859
    {
    (yylhs.value.TOPHASL) = new HaslFormulasTop(PROBABILITY);
}
#line 1759 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 154:
#line 792 "Lha-parser.yy" // lalr1.cc:859
    {
    Reader.MyLha.FinalStateCond.push_back(*(yystack_[1].value.name));
    (yylhs.value.TOPHASL) = new HaslFormulasTop(PROBCOND,(size_t)Reader.MyLha.FinalStateCond.size()-1);
}
#line 1768 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 155:
#line 796 "Lha-parser.yy" // lalr1.cc:859
    {
    (yylhs.value.TOPHASL) = new HaslFormulasTop(EXISTS);
}
#line 1776 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 156:
#line 799 "Lha-parser.yy" // lalr1.cc:859
    {
    (yylhs.value.TOPHASL) = new HaslFormulasTop(NOTALLS);
}
#line 1784 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 157:
#line 802 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = new HaslFormulasTop((yystack_[3].value.RealVal),(yystack_[1].value.RealVal));
}
#line 1792 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 158:
#line 805 "Lha-parser.yy" // lalr1.cc:859
    {
	
	for(double bucket = (yystack_[3].value.RealVal) ; bucket < (yystack_[1].value.RealVal) ; bucket+= (yystack_[5].value.RealVal)){
		std::ostringstream algPDF;
		algPDF << "(("<<(yystack_[7].value.expression)<<" >= "<<bucket<<"&& "<<(yystack_[7].value.expression)<<"<"<<bucket+(yystack_[5].value.RealVal)<<") ? 1:0)";
		
		Reader.MyLha.Algebraic.push_back(algPDF.str());
		Reader.MyLha.HASLtop.push_back(
			new HaslFormulasTop((size_t)Reader.MyLha.Algebraic.size()-1));
		Reader.MyLha.HASLtop.back()->TypeOp = PDF_PART;
		std::ostringstream s; s<<"$_$: Value in ["<< bucket<< " , "<<bucket+(yystack_[5].value.RealVal)<<"]";
		Reader.MyLha.HASLname.push_back(s.str());
	}
	(yylhs.value.TOPHASL) = NULL;
}
#line 1812 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 159:
#line 820 "Lha-parser.yy" // lalr1.cc:859
    {
	
	for(double bucket = (yystack_[3].value.RealVal) ; bucket < (yystack_[1].value.RealVal) ; bucket+= (yystack_[5].value.RealVal)){
		std::ostringstream algCDF;
		algCDF << "(("<<(yystack_[7].value.expression)<<" <= "<<bucket<<") ? 1:0)";
		
		Reader.MyLha.Algebraic.push_back(algCDF.str());
		Reader.MyLha.HASLtop.push_back(
		new HaslFormulasTop((size_t)Reader.MyLha.Algebraic.size()-1));
		Reader.MyLha.HASLtop.back()->TypeOp = CDF_PART;
		std::ostringstream s; s<<"$_$: Value in [-infinity , "<< bucket<<"]";
		Reader.MyLha.HASLname.push_back(s.str());
	}
	(yylhs.value.TOPHASL) = NULL;
}
#line 1832 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 160:
#line 835 "Lha-parser.yy" // lalr1.cc:859
    {
	Reader.MyLha.Algebraic.push_back((yystack_[1].value.expression));
	char tmp[5000];
	sprintf(tmp,"(%s * %s)", (yystack_[1].value.expression),(yystack_[1].value.expression));
	Reader.MyLha.Algebraic.push_back(tmp);
	(yylhs.value.TOPHASL) = new HaslFormulasTop(HASL_MINUS,
		new HaslFormulasTop((size_t)Reader.MyLha.Algebraic.size()-1),
		new HaslFormulasTop(HASL_TIME,
			new HaslFormulasTop((size_t)Reader.MyLha.Algebraic.size()-2),
			new HaslFormulasTop((size_t)Reader.MyLha.Algebraic.size()-2)));
}
#line 1848 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 161:
#line 846 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = (yystack_[1].value.TOPHASL);
}
#line 1856 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 162:
#line 849 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = new HaslFormulasTop(HASL_PLUS, (yystack_[2].value.TOPHASL),(yystack_[0].value.TOPHASL));
}
#line 1864 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 163:
#line 852 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = new HaslFormulasTop(HASL_MINUS, (yystack_[2].value.TOPHASL),(yystack_[0].value.TOPHASL));
}
#line 1872 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 164:
#line 855 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = new HaslFormulasTop(HASL_TIME, (yystack_[2].value.TOPHASL), (yystack_[0].value.TOPHASL));
}
#line 1880 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 165:
#line 858 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = new HaslFormulasTop(HASL_DIV, (yystack_[2].value.TOPHASL),(yystack_[0].value.TOPHASL));
}
#line 1888 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 166:
#line 861 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = new HaslFormulasTop((double)(yystack_[0].value.IntVal),0.0,1.0);
}
#line 1896 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 167:
#line 864 "Lha-parser.yy" // lalr1.cc:859
    {
	(yylhs.value.TOPHASL) = new HaslFormulasTop((double)(yystack_[0].value.RealVal),0.0,1.0);
}
#line 1904 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 168:
#line 868 "Lha-parser.yy" // lalr1.cc:859
    {string ss=(yystack_[0].value.expression);
	sprintf((yylhs.value.expression),"LhaFunc[%d]", Reader.MyLha.LhaFunction[ss]);
}
#line 1912 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 169:
#line 871 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"min(%s,%s)", (yystack_[3].value.expression),(yystack_[1].value.expression));}
#line 1918 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 170:
#line 872 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"max(%s,%s)", (yystack_[3].value.expression),(yystack_[1].value.expression));}
#line 1924 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 171:
#line 873 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"-%s", (yystack_[0].value.expression));}
#line 1930 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 172:
#line 874 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"floor(%s)", (yystack_[1].value.expression));}
#line 1936 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 173:
#line 875 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"(%s)", (yystack_[1].value.expression));}
#line 1942 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 174:
#line 876 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"pow(%s , %s)", (yystack_[2].value.expression),(yystack_[0].value.expression));}
#line 1948 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 175:
#line 877 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"(%s + %s)", (yystack_[2].value.expression),(yystack_[0].value.expression));}
#line 1954 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 176:
#line 878 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"(%s - %s)", (yystack_[2].value.expression),(yystack_[0].value.expression));}
#line 1960 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 177:
#line 879 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"(%s * %s)", (yystack_[2].value.expression),(yystack_[0].value.expression));}
#line 1966 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 178:
#line 880 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"(%s / %s)", (yystack_[2].value.expression),(yystack_[0].value.expression));}
#line 1972 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 179:
#line 882 "Lha-parser.yy" // lalr1.cc:859
    {std::ostringstream s; s<<(yystack_[1].value.expression);
	if(Reader.MyLha.LinearForm.find(s.str())==Reader.MyLha.LinearForm.end())
	{int i=Reader.MyLha.LinearForm.size();Reader.MyLha.LinearForm[s.str()]=i;}
	Reader.MyLha.LhaFuncArg.push_back(Reader.MyLha.LinearForm[s.str()]);
	Reader.MyLha.LhaFuncType.push_back("Last");
	string ss="Last("; ss.append(s.str()); ss.append(")");
	if(Reader.MyLha.LhaFunction.find(ss)==Reader.MyLha.LhaFunction.end())
	{int i=Reader.MyLha.LhaFunction.size();Reader.MyLha.LhaFunction[ss]=i;}
	sprintf((yylhs.value.expression),"%s", ss.c_str());
}
#line 1987 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 180:
#line 892 "Lha-parser.yy" // lalr1.cc:859
    {std::ostringstream s; s<<(yystack_[1].value.expression);
	if(Reader.MyLha.LinearForm.find(s.str())==Reader.MyLha.LinearForm.end())
	{int i=Reader.MyLha.LinearForm.size();Reader.MyLha.LinearForm[s.str()]=i;}
	Reader.MyLha.LhaFuncArg.push_back(Reader.MyLha.LinearForm[s.str()]);
	Reader.MyLha.LhaFuncType.push_back("Min");
	string ss="Min("; ss.append(s.str()); ss.append(")");
	if(Reader.MyLha.LhaFunction.find(ss)==Reader.MyLha.LhaFunction.end())
	{int i=Reader.MyLha.LhaFunction.size();Reader.MyLha.LhaFunction[ss]=i;}
	sprintf((yylhs.value.expression),"%s", ss.c_str());
}
#line 2002 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 181:
#line 902 "Lha-parser.yy" // lalr1.cc:859
    {std::ostringstream s; s<<(yystack_[1].value.expression);
	if(Reader.MyLha.LinearForm.find(s.str())==Reader.MyLha.LinearForm.end())
	{int i=Reader.MyLha.LinearForm.size();Reader.MyLha.LinearForm[s.str()]=i;}
	Reader.MyLha.LhaFuncArg.push_back(Reader.MyLha.LinearForm[s.str()]);
	Reader.MyLha.LhaFuncType.push_back("Max");
	string ss="Max("; ss.append(s.str()); ss.append(")");
	if(Reader.MyLha.LhaFunction.find(ss)==Reader.MyLha.LhaFunction.end())
	{int i=Reader.MyLha.LhaFunction.size();Reader.MyLha.LhaFunction[ss]=i;}
	sprintf((yylhs.value.expression),"%s", ss.c_str());
}
#line 2017 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 182:
#line 912 "Lha-parser.yy" // lalr1.cc:859
    {std::ostringstream s; s<<(yystack_[1].value.expression);
	if(Reader.MyLha.LinearForm.find(s.str())==Reader.MyLha.LinearForm.end())
	{int i=Reader.MyLha.LinearForm.size();Reader.MyLha.LinearForm[s.str()]=i;}
	Reader.MyLha.LhaFuncArg.push_back(Reader.MyLha.LinearForm[s.str()]);
	Reader.MyLha.LhaFuncType.push_back("Integral");
	string ss="Integral("; ss.append(s.str()); ss.append(")");
	if(Reader.MyLha.LhaFunction.find(ss)==Reader.MyLha.LhaFunction.end())
	{int i=Reader.MyLha.LhaFunction.size();Reader.MyLha.LhaFunction[ss]=i;}
	sprintf((yylhs.value.expression),"%s", ss.c_str());
}
#line 2032 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 183:
#line 922 "Lha-parser.yy" // lalr1.cc:859
    {std::ostringstream s; s<<(yystack_[1].value.expression);
		if(Reader.MyLha.LinearForm.find(s.str())==Reader.MyLha.LinearForm.end())
		{int i=Reader.MyLha.LinearForm.size();Reader.MyLha.LinearForm[s.str()]=i;}
		Reader.MyLha.LhaFuncArg.push_back(Reader.MyLha.LinearForm[s.str()]);
		Reader.MyLha.LhaFuncType.push_back("Mean");
		string ss="Mean("; ss.append(s.str()); ss.append(")");
		if(Reader.MyLha.LhaFunction.find(ss)==Reader.MyLha.LhaFunction.end())
		{int i=Reader.MyLha.LhaFunction.size();Reader.MyLha.LhaFunction[ss]=i;}
		sprintf((yylhs.value.expression),"%s", ss.c_str());
}
#line 2047 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 184:
#line 933 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s", (yystack_[0].value.expression));  }
#line 2053 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 185:
#line 934 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s - %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 2059 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 186:
#line 935 "Lha-parser.yy" // lalr1.cc:859
    {sprintf((yylhs.value.expression),"%s + %s", (yystack_[2].value.expression), (yystack_[0].value.expression));  }
#line 2065 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 187:
#line 938 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{sprintf((yylhs.value.expression),"Vars->%s", (yystack_[0].value.name)->c_str());}
	else if(Reader.MyLha.PlaceIndex.find(*(yystack_[0].value.name))!=Reader.MyLha.PlaceIndex.end())
	{std::ostringstream s; s<<" Marking.P->_PL_"<< (yystack_[0].value.name)->c_str();
			if(Reader.MyLha.MyGspn->placeStruct[Reader.MyLha.PlaceIndex[*(yystack_[0].value.name)]].colorDom !=0 )s <<".card()";
		sprintf((yylhs.value.expression), "%s ",(s.str()).c_str());
	} else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable or a place name"<<endl;YYABORT;}
}
#line 2078 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 188:
#line 946 "Lha-parser.yy" // lalr1.cc:859
    {
    if(Reader.MyLha.Vars.find(*(yystack_[3].value.name))!=Reader.MyLha.Vars.label.size()){
        sprintf((yylhs.value.expression),"Vars->%s[%s]", (yystack_[3].value.name)->c_str(), (yystack_[1].value.expression));
	} else {cout<<*(yystack_[3].value.name)<<" is not a Lha array variable "<<endl;YYABORT;}
}
#line 2088 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 189:
#line 954 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{sprintf((yylhs.value.expression),"(%s) * Vars->%s", (yystack_[3].value.expression), (yystack_[0].value.name)->c_str());
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 2097 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 190:
#line 959 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{sprintf((yylhs.value.expression),"%d * Vars->%s", (yystack_[2].value.IntVal), (yystack_[0].value.name)->c_str());
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 2106 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 191:
#line 964 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{sprintf((yylhs.value.expression),"%f * Vars->%s", (yystack_[2].value.RealVal), (yystack_[0].value.name)->c_str());
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 2115 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 192:
#line 970 "Lha-parser.yy" // lalr1.cc:859
    { sprintf((yylhs.value.expression),"%i ", (yystack_[0].value.IntVal));
}
#line 2122 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 193:
#line 973 "Lha-parser.yy" // lalr1.cc:859
    { sprintf((yylhs.value.expression),"%f ", (yystack_[0].value.RealVal));}
#line 2128 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 194:
#line 976 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{if(Reader.MyLha.LhaRealConstant.find(*(yystack_[2].value.name))!=Reader.MyLha.LhaRealConstant.end())
		{sprintf((yylhs.value.expression),"%f * Vars->%s", Reader.MyLha.LhaRealConstant[*(yystack_[2].value.name)],(yystack_[0].value.name)->c_str());
		}
		else
		{
			if(Reader.MyLha.PlaceIndex.find(*(yystack_[2].value.name))!=Reader.MyLha.PlaceIndex.end())
			{sprintf((yylhs.value.expression),"Marking.P->_PL_%s * Vars->%s", (yystack_[2].value.name)->c_str() ,(yystack_[0].value.name)->c_str());
			}
			else
			{
				cout<<*(yystack_[2].value.name)<<" is not Petri-net Place or a definded constant "<<endl;
				YYABORT;
			}
		}
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}
}
#line 2151 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 195:
#line 995 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{sprintf((yylhs.value.expression),"-Vars->%s", (yystack_[0].value.name)->c_str());}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 2159 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 196:
#line 999 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{sprintf((yylhs.value.expression),"-(%s) * Vars->%s", (yystack_[3].value.expression), (yystack_[0].value.name)->c_str());
	}
	else {cout<<*(yystack_[1].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 2168 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 197:
#line 1004 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{sprintf((yylhs.value.expression),"-%d * Vars->%s", (yystack_[2].value.IntVal), (yystack_[0].value.name)->c_str());
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 2177 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 198:
#line 1009 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{sprintf((yylhs.value.expression),"-%f * Vars->%s", (yystack_[2].value.RealVal), (yystack_[0].value.name)->c_str());
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}}
#line 2186 "Lha-parser.cc" // lalr1.cc:859
    break;

  case 199:
#line 1014 "Lha-parser.yy" // lalr1.cc:859
    { if(Reader.MyLha.Vars.find(*(yystack_[0].value.name))!=Reader.MyLha.Vars.label.size())
	{if(Reader.MyLha.LhaRealConstant.find(*(yystack_[2].value.name))!=Reader.MyLha.LhaRealConstant.end())
		{sprintf((yylhs.value.expression),"-%f * Vars->%s", Reader.MyLha.LhaRealConstant[*(yystack_[2].value.name)],(yystack_[0].value.name)->c_str());
		}
		else
		{
			if(Reader.MyLha.PlaceIndex.find(*(yystack_[2].value.name))!=Reader.MyLha.PlaceIndex.end())
			{sprintf((yylhs.value.expression),"-Marking.P->_PL_%s * Vars->%s", (yystack_[2].value.name)->c_str() ,(yystack_[0].value.name)->c_str());
			}
			else
			{
				cout<<*(yystack_[2].value.name)<<" is not Petri-net Place or a definded constant "<<endl;
				YYABORT;
			}
		}
	}
	else {cout<<*(yystack_[0].value.name)<<" is not a Lha variable"<<endl;YYABORT;}
}
#line 2209 "Lha-parser.cc" // lalr1.cc:859
    break;


#line 2213 "Lha-parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  Lha_parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  Lha_parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int Lha_parser::yypact_ninf_ = -358;

  const signed char Lha_parser::yytable_ninf_ = -7;

  const short int
  Lha_parser::yypact_[] =
  {
     146,    38,  -358,  -358,    18,    12,    16,    25,    66,   539,
      88,   115,    87,   125,  -358,  -358,   148,   -46,   -16,   111,
     124,  -358,    10,   287,    18,   604,   199,   199,   142,   195,
     -46,   204,   251,   199,   199,  -358,   224,   250,   171,   213,
     219,   176,   259,   263,   201,   232,    10,   234,   242,  -358,
    -358,  -358,  -358,    18,    18,    18,    18,   291,  -358,   199,
     199,   283,   292,   318,   332,   333,   357,   358,   372,   413,
    -358,   419,   286,  -358,   317,   171,   334,   359,   300,   315,
     344,   346,   378,   379,  -358,   362,   341,  -358,  -358,   405,
     417,   367,   395,    10,  -358,  -358,  -358,  -358,  -358,  -358,
     235,   235,  -358,   424,   351,   199,   199,   199,   207,   207,
     207,   207,   207,  -358,   199,   199,   199,   199,   199,  -358,
    -358,   418,  -358,  -358,  -358,   210,   210,   430,   458,   407,
     409,  -358,  -358,   455,   457,     9,   483,  -358,  -358,   436,
     326,   331,     6,   392,   469,   123,   246,   143,  -358,   255,
     606,   608,   610,   467,   467,   351,   351,  -358,   490,  -358,
    -358,  -358,   493,   501,  -358,     2,  -358,     3,   502,   505,
     123,   226,  -358,   507,     8,  -358,    20,  -358,   199,   199,
     226,   509,   534,   535,   528,  -358,  -358,   123,   123,   533,
     540,   541,   447,   511,   522,   523,   123,  -358,   207,   207,
    -358,  -358,  -358,  -358,  -358,   210,   210,   562,   571,   575,
     573,   578,    -2,  -358,   579,   551,   505,    14,   594,  -358,
     226,   226,   583,   595,   612,   619,   188,   616,    15,   611,
     626,   613,   452,   459,   614,  -358,  -358,  -358,   628,   464,
     403,   123,   123,   123,   629,   123,   123,   123,   123,   123,
     654,   669,   670,   475,  -358,  -358,   666,   677,  -358,  -358,
    -358,  -358,   678,   681,  -358,   685,   683,  -358,  -358,   236,
     566,    85,   226,   226,   226,   226,  -358,   226,   226,   226,
     226,   686,  -358,   687,  -358,  -358,  -358,  -358,  -358,  -358,
     684,   682,  -358,   487,   340,   345,   690,   663,   663,   403,
     403,  -358,  -358,  -358,  -358,   667,   210,   210,   279,  -358,
     689,  -358,   136,   618,   688,  -358,   492,   374,   381,   385,
     671,    85,    85,  -358,   692,   691,   628,  -358,  -358,   123,
     123,  -358,   695,   696,   697,   279,   279,  -358,  -358,   647,
     316,  -358,   698,  -358,  -358,  -358,   226,   226,   226,   226,
    -358,   694,  -358,   498,   503,  -358,  -358,  -358,   408,   108,
    -358,   123,   123,   123,   123,   123,   699,   703,   279,   279,
     700,   570,   577,   581,   593,   693,  -358,  -358,  -358,   624,
     624,   624,   624,   624,   708,  -358,  -358,   701,   704,  -358,
    -358,  -358,  -358,  -358,   706,    80,  -358,   -10,   123,   708,
     705,  -358,   702,   711,   710,  -358,   624,  -358,   713,   653,
    -358,    21,   167,  -358,  -358,   717,  -358,   707,   709,   712,
     123,  -358,   387,   715,   714,   161,  -358,  -358,   718,   721,
     722,   515,   716,   719,   720,   123,    11,   167,   123,   123,
     123,   302,   302,  -358,  -358,  -358,   723,   724,   725,   726,
     526,  -358,   727,   729,  -358,   624,   624,   624,  -358,  -358,
     728,  -358,  -358,  -358,   730,    75,    23,  -358,   731,  -358,
     737,   226,   243,   727,  -358,  -358,  -358,   630,   732,  -358,
    -358,   243,   243,   733,   735,   738,   652,  -358,   734,   236,
     531,   431,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   639,   739,  -358,   538,   356,   370,   736,   736,   431,
     431,  -358,   652,  -358,  -358,  -358,   243,   243,   543,   554,
    -358,  -358
  };

  const unsigned char
  Lha_parser::yydefact_[] =
  {
      59,     0,   167,   166,     0,     0,     0,   152,     0,    59,
       0,     0,     0,     0,   155,   156,     0,     0,     0,    58,
      57,     5,   144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     1,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    60,     0,     0,     0,    56,
      55,   145,   147,     0,     0,     0,     0,     0,   161,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     168,     0,     0,   153,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     4,     0,     0,    78,    79,     0,
       0,     0,     0,     0,    61,     8,    66,    67,   165,   164,
     162,   163,   146,     0,   171,     0,     0,     0,     0,     0,
       0,     0,     0,   151,     0,     0,     0,     0,     0,   160,
     154,     0,     3,    65,    64,     0,     0,     0,     0,     0,
       0,    86,    87,     0,     0,     0,     0,     7,   173,     0,
       0,     0,   187,   193,   192,     0,     0,     0,   184,     0,
       0,     0,     0,   178,   177,   175,   176,   174,     0,   150,
     148,   149,     0,     0,    81,     0,    84,     0,     0,     0,
       0,     0,    69,     0,     0,    76,     0,   172,     0,     0,
       0,     0,     0,     0,    26,    24,    25,     0,     0,     0,
       0,     0,     0,   195,     0,     0,     0,   180,     0,     0,
     181,   179,   182,   183,   157,     0,     0,     0,     0,     0,
       0,     0,     0,    89,     0,     0,   109,     0,    10,     9,
       0,     0,     0,     0,     0,     0,     0,    70,     0,     0,
       0,     0,     0,     0,     0,   194,   191,   190,     0,     0,
      29,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   186,   185,     0,     0,    82,    80,
      85,    83,     0,     0,    90,     0,     0,   110,    63,     0,
       0,    14,     0,     0,     0,     0,    62,     0,     0,     0,
       0,     0,    72,     0,    68,    77,    75,   169,   170,   188,
       0,     0,    28,     0,     0,     0,     0,    30,    33,    31,
      32,    34,   199,   198,   197,     0,     0,     0,     0,    88,
       0,   108,    10,     0,     0,    13,     0,     0,     0,     0,
      17,    15,    16,    18,     0,    73,    53,    27,    35,     0,
       0,   189,     0,     0,     0,     0,     0,    96,    97,     0,
       0,    98,     0,    12,    11,    19,     0,     0,     0,     0,
      71,     0,    54,     0,     0,   196,   158,   159,     0,     0,
     102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,    37,   101,   103,
     105,   104,   106,   107,     0,    92,    99,   100,     0,    20,
      21,    22,    23,    74,     0,     0,    93,     0,     0,     0,
       0,   112,   113,     0,     0,   115,    95,    94,     0,     0,
     117,     0,     0,    91,   114,     0,   116,   128,     0,     0,
       0,   121,     0,     0,   119,     0,   125,   118,     0,     0,
       0,     0,   133,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   132,   131,   130,     0,     0,     0,     0,
       0,   139,     0,     0,   120,   122,   124,   123,   127,   126,
       0,   137,   136,   135,     0,     0,     0,   140,     0,   129,
       0,     0,     0,     0,   138,   111,   134,     0,    40,    38,
      39,     0,     0,     0,     0,     0,   142,   141,     0,     0,
       0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    43,     0,     0,     0,    45,    48,    46,
      47,    49,   143,    41,    42,    50,     0,     0,     0,     0,
      51,    52
  };

  const short int
  Lha_parser::yypgoto_[] =
  {
    -358,  -358,   744,  -180,  -140,  -357,  -263,  -358,   740,  -358,
     741,   743,   742,   745,  -358,   679,  -358,   746,   747,  -358,
     749,  -358,   657,   648,  -358,   521,  -358,   347,  -253,  -358,
     672,   542,  -358,  -358,   354,  -358,   319,  -358,  -358,  -152,
    -358,  -358,   281,   -20,  -358,  -125,   109,     5,  -358,   240,
     137
  };

  const short int
  Lha_parser::yydefgoto_[] =
  {
      -1,    16,    17,   226,   339,   486,   291,    18,    44,    45,
      19,    20,    46,    47,   174,    48,   176,    38,    39,   165,
      40,   167,    84,    85,   212,   213,   395,   396,   340,   341,
      86,   215,   216,   404,   405,   411,   423,   424,   425,   426,
     453,   466,   467,    21,    22,   162,    23,    69,    70,   147,
     148
  };

  const short int
  Lha_parser::yytable_[] =
  {
     234,   163,    51,   401,   402,   192,   314,   211,    36,    37,
     207,   209,   172,     1,     2,     3,   228,   180,   282,     4,
     268,    26,     2,     3,   451,    27,    95,     4,   230,   415,
     217,   473,    71,    41,    28,   181,    42,    43,    78,    79,
     270,   271,   245,   246,   247,   248,   249,   239,   240,     5,
       6,     7,     8,   403,    24,   173,   253,     5,     6,     7,
       8,   283,   263,   352,   103,   104,   208,   210,    12,    13,
      14,    15,   229,   137,   452,    29,    12,    13,    14,    15,
     256,   257,   359,   360,   231,   416,   471,   474,   399,   313,
     400,   472,   316,   317,   318,   319,    33,   320,   321,   322,
     323,   293,   294,   295,    31,   297,   298,   299,   300,   301,
     139,   140,   141,    25,   277,   386,   387,   280,   378,   153,
     154,   155,   156,   157,   490,   491,   184,   185,   186,   368,
     369,    32,   187,    57,    34,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   326,    72,    -2,   269,    35,     1,
       2,     3,    73,   197,   188,     4,   189,   190,   191,   518,
     519,    10,    98,    99,   100,   101,   371,   372,   373,   374,
     417,   418,   419,   198,   199,    11,   420,   438,   439,   440,
     421,   333,   334,   232,   233,     5,     6,     7,     8,   353,
     354,   441,   442,     9,   276,   358,    10,    11,   422,    74,
      -6,    -6,    89,    90,    12,    13,    14,    15,    59,    76,
     142,   143,   144,   159,   160,   161,   145,   277,   278,   279,
     280,   379,   380,   381,   382,   383,   502,    82,    83,   218,
      60,   219,    61,    62,    63,   220,    64,    65,   146,   312,
      80,   219,    66,    67,    68,   220,   478,   479,   480,   193,
     194,   195,   481,    42,    43,   196,    77,   221,   406,   222,
     223,   224,   225,    53,    54,   200,    81,   221,    37,   222,
     223,   224,   225,    36,   482,    91,   483,   484,   485,    92,
     431,    41,   184,   185,   186,   198,   199,    43,   335,   458,
     459,   477,   105,    52,    42,   450,   120,   102,   455,   456,
     457,   106,   336,   337,   338,   417,   418,   419,   125,   501,
     188,   420,   189,   190,   191,    53,    54,    55,    56,    53,
      54,    55,    56,   126,   366,   121,   367,   107,   114,   115,
     116,   117,   118,   422,   178,   254,   255,   368,   369,   179,
     123,   108,   109,   114,   115,   116,   117,   118,   329,   149,
     150,   151,   152,   330,   114,   115,   116,   117,   118,   114,
     115,   116,   117,   118,   516,   124,   110,   111,   245,   246,
     247,   248,   249,   245,   246,   247,   248,   249,   517,   114,
     115,   112,   347,   118,   495,   496,   497,   498,   499,   348,
     432,   433,   434,   349,   129,   130,   435,    82,   495,   496,
     497,   498,   499,   277,   278,   279,   280,   127,   133,   128,
     277,   278,   279,   280,   277,   278,   279,   280,   292,    83,
     134,   182,   158,   113,   361,   362,   363,   364,   365,   119,
     135,   245,   246,   164,   138,   249,   245,   246,   247,   248,
     249,   114,   115,   116,   117,   118,   177,   114,   115,   116,
     117,   118,   114,   115,   116,   117,   118,   244,   136,   495,
     496,   166,   287,   499,   114,   115,   116,   117,   118,   288,
     168,   170,   169,   171,   292,   245,   246,   247,   248,   249,
     114,   115,   116,   117,   118,   305,   175,   114,   115,   116,
     117,   118,   245,   246,   247,   248,   249,   328,   183,   118,
     204,   205,   345,   245,   246,   247,   248,   249,   376,   206,
     227,   211,   235,   377,   214,   245,   246,   247,   248,   249,
     346,   277,   278,   279,   280,   446,   245,   246,   247,   248,
     249,   245,   246,   247,   248,   249,   464,   236,   237,   238,
     250,   503,   241,   245,   246,   247,   248,   249,   515,   242,
     243,   251,   252,   520,   245,   246,   247,   248,   249,   495,
     496,   497,   498,   499,   521,   258,   495,   496,   497,   498,
     499,   495,   496,   497,   498,   499,   315,   259,   260,   261,
     389,   262,   495,   496,   497,   498,   499,   390,   265,    10,
      11,   391,   272,    -6,    -6,   277,   278,   279,   280,   277,
     278,   279,   280,   392,   273,   269,   277,   278,   279,   280,
     277,   278,   279,   280,    58,   266,   201,   284,   202,   286,
     203,   274,   277,   278,   279,   280,   289,   281,   275,   285,
     343,   290,    53,    54,    55,    56,   198,   199,   198,   199,
     198,   199,   488,   277,   278,   279,   280,   277,   278,   279,
     280,   513,   245,   246,   247,   248,   249,   302,   296,   277,
     278,   279,   280,   361,   362,   363,   364,   365,   277,   278,
     279,   280,   303,   304,   306,   245,   246,   247,   248,   249,
     495,   496,   497,   498,   499,   307,   308,   309,   310,   311,
     325,   324,   326,   331,   327,   249,   332,   342,   355,   375,
     344,   370,   351,   280,   350,   393,   356,   357,   384,   385,
     388,   394,   397,   398,   410,   408,   403,   409,   412,   413,
     427,   443,   368,   436,   444,   445,    96,   461,   462,   463,
     465,   469,   122,   264,   132,   437,   428,   475,   429,   468,
     476,   430,   492,   489,   493,   447,   407,   494,   448,   449,
     500,   514,   460,    30,   487,     0,   454,   131,   267,   470,
       0,    50,    49,   414,     0,     0,     0,     0,   499,     0,
       0,     0,     0,     0,     0,     0,    75,     0,     0,     0,
       0,     0,     0,     0,     0,    94,    93,    88,    87,     0,
       0,     0,     0,    97
  };

  const short int
  Lha_parser::yycheck_[] =
  {
     180,   126,    22,    13,    14,   145,   269,     9,    54,    55,
       8,     8,     3,     3,     4,     5,     8,    11,     3,     9,
       6,     9,     4,     5,    13,     9,    46,     9,     8,     8,
     170,     8,    27,    49,     9,    29,    52,    53,    33,    34,
     220,   221,    28,    29,    30,    31,    32,   187,   188,    39,
      40,    41,    42,    63,    16,    46,   196,    39,    40,    41,
      42,    46,    64,   326,    59,    60,    64,    64,    58,    59,
      60,    61,    64,    93,    63,     9,    58,    59,    60,    61,
     205,   206,   335,   336,    64,    64,    11,    64,     8,   269,
      10,    16,   272,   273,   274,   275,     9,   277,   278,   279,
     280,   241,   242,   243,    16,   245,   246,   247,   248,   249,
     105,   106,   107,     4,    29,   368,   369,    32,    10,   114,
     115,   116,   117,   118,   481,   482,     3,     4,     5,    21,
      22,    16,     9,    24,     9,   492,   493,   494,   495,   496,
     497,   498,   499,   500,     8,     3,     0,    11,     0,     3,
       4,     5,    10,    10,    31,     9,    33,    34,    35,   516,
     517,    50,    53,    54,    55,    56,   346,   347,   348,   349,
       3,     4,     5,    30,    31,    51,     9,    16,    17,    18,
      13,   306,   307,   178,   179,    39,    40,    41,    42,   329,
     330,    30,    31,    47,     6,   335,    50,    51,    31,     4,
      54,    55,    26,    27,    58,    59,    60,    61,     9,     5,
       3,     4,     5,     3,     4,     5,     9,    29,    30,    31,
      32,   361,   362,   363,   364,   365,   489,    56,    57,     3,
      31,     5,    33,    34,    35,     9,    37,    38,    31,     3,
      16,     5,    43,    44,    45,     9,     3,     4,     5,     3,
       4,     5,     9,    52,    53,     9,     5,    31,   398,    33,
      34,    35,    36,    28,    29,    10,    16,    31,    55,    33,
      34,    35,    36,    54,    31,    16,    33,    34,    35,    16,
     420,    49,     3,     4,     5,    30,    31,    53,     9,   441,
     442,   471,     9,     6,    52,   435,    10,     6,   438,   439,
     440,     9,    23,    24,    25,     3,     4,     5,     8,   489,
      31,     9,    33,    34,    35,    28,    29,    30,    31,    28,
      29,    30,    31,     8,     8,     8,    10,     9,    28,    29,
      30,    31,    32,    31,     8,   198,   199,    21,    22,     8,
       6,     9,     9,    28,    29,    30,    31,    32,     8,   109,
     110,   111,   112,     8,    28,    29,    30,    31,    32,    28,
      29,    30,    31,    32,     8,     6,     9,     9,    28,    29,
      30,    31,    32,    28,    29,    30,    31,    32,     8,    28,
      29,     9,     8,    32,    28,    29,    30,    31,    32,     8,
       3,     4,     5,     8,    16,    16,     9,    56,    28,    29,
      30,    31,    32,    29,    30,    31,    32,    63,     3,    63,
      29,    30,    31,    32,    29,    30,    31,    32,    10,    57,
       3,    29,     4,    10,    16,    17,    18,    19,    20,    10,
      63,    28,    29,     3,    10,    32,    28,    29,    30,    31,
      32,    28,    29,    30,    31,    32,    10,    28,    29,    30,
      31,    32,    28,    29,    30,    31,    32,    10,    63,    28,
      29,     3,    10,    32,    28,    29,    30,    31,    32,    10,
      63,    16,    63,    16,    10,    28,    29,    30,    31,    32,
      28,    29,    30,    31,    32,    10,     3,    28,    29,    30,
      31,    32,    28,    29,    30,    31,    32,    10,    29,    32,
      10,     8,    10,    28,    29,    30,    31,    32,    10,     8,
       3,     9,     3,    10,     9,    28,    29,    30,    31,    32,
      28,    29,    30,    31,    32,    10,    28,    29,    30,    31,
      32,    28,    29,    30,    31,    32,    10,     3,     3,    11,
      29,    10,     9,    28,    29,    30,    31,    32,    10,     9,
       9,    29,    29,    10,    28,    29,    30,    31,    32,    28,
      29,    30,    31,    32,    10,     3,    28,    29,    30,    31,
      32,    28,    29,    30,    31,    32,    10,     6,     3,     6,
      10,     3,    28,    29,    30,    31,    32,    10,     9,    50,
      51,    10,     9,    54,    55,    29,    30,    31,    32,    29,
      30,    31,    32,    10,     9,    11,    29,    30,    31,    32,
      29,    30,    31,    32,    10,    64,    10,     6,    10,     6,
      10,     9,    29,    30,    31,    32,    12,    11,     9,     3,
      12,     3,    28,    29,    30,    31,    30,    31,    30,    31,
      30,    31,    12,    29,    30,    31,    32,    29,    30,    31,
      32,    12,    28,    29,    30,    31,    32,     3,    29,    29,
      30,    31,    32,    16,    17,    18,    19,    20,    29,    30,
      31,    32,     3,     3,     8,    28,    29,    30,    31,    32,
      28,    29,    30,    31,    32,     8,     8,     6,     3,     6,
       3,     5,     8,     3,    12,    32,    29,     8,     3,     5,
      12,     3,    11,    32,    12,    12,    10,    10,     9,     6,
      10,     3,     8,     7,     3,    10,    63,    15,     8,     6,
       3,     3,    21,     8,     3,     3,    47,     3,     3,     3,
       3,     3,    75,   212,    86,    21,    29,     6,    29,    10,
       3,    29,     9,    11,     9,    29,   399,     9,    29,    29,
      16,    12,    29,     9,   473,    -1,   437,    85,   216,    29,
      -1,    20,    19,   409,    -1,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    44,    40,    39,    -1,
      -1,    -1,    -1,    48
  };

  const unsigned char
  Lha_parser::yystos_[] =
  {
       0,     3,     4,     5,     9,    39,    40,    41,    42,    47,
      50,    51,    58,    59,    60,    61,    66,    67,    72,    75,
      76,   108,   109,   111,    16,   111,     9,     9,     9,     9,
      67,    16,    16,     9,     9,     0,    54,    55,    82,    83,
      85,    49,    52,    53,    73,    74,    77,    78,    80,    76,
      75,   108,     6,    28,    29,    30,    31,   111,    10,     9,
      31,    33,    34,    35,    37,    38,    43,    44,    45,   112,
     113,   112,     3,    10,     4,    82,     5,     5,   112,   112,
      16,    16,    56,    57,    87,    88,    95,    85,    83,    26,
      27,    16,    16,    77,    73,   108,    80,    78,   111,   111,
     111,   111,     6,   112,   112,     9,     9,     9,     9,     9,
       9,     9,     9,    10,    28,    29,    30,    31,    32,    10,
      10,     8,    87,     6,     6,     8,     8,    63,    63,    16,
      16,    95,    88,     3,     3,    63,    63,   108,    10,   112,
     112,   112,     3,     4,     5,     9,    31,   114,   115,   114,
     114,   114,   114,   112,   112,   112,   112,   112,     4,     3,
       4,     5,   110,   110,     3,    84,     3,    86,    63,    63,
      16,    16,     3,    46,    79,     3,    81,    10,     8,     8,
      11,    29,    29,    29,     3,     4,     5,     9,    31,    33,
      34,    35,    69,     3,     4,     5,     9,    10,    30,    31,
      10,    10,    10,    10,    10,     8,     8,     8,    64,     8,
      64,     9,    89,    90,     9,    96,    97,    69,     3,     5,
       9,    31,    33,    34,    35,    36,    68,     3,     8,    64,
       8,    64,   112,   112,    68,     3,     3,     3,    11,    69,
      69,     9,     9,     9,    10,    28,    29,    30,    31,    32,
      29,    29,    29,    69,   115,   115,   110,   110,     3,     6,
       3,     6,     3,    64,    90,     9,    64,    96,     6,    11,
      68,    68,     9,     9,     9,     9,     6,    29,    30,    31,
      32,    11,     3,    46,     6,     3,     6,    10,    10,    12,
       3,    71,    10,    69,    69,    69,    29,    69,    69,    69,
      69,    69,     3,     3,     3,    10,     8,     8,     8,     6,
       3,     6,     3,    68,    71,    10,    68,    68,    68,    68,
      68,    68,    68,    68,     5,     3,     8,    12,    10,     8,
       8,     3,    29,   110,   110,     9,    23,    24,    25,    69,
      93,    94,     8,    12,    12,    10,    28,     8,     8,     8,
      12,    11,    71,    69,    69,     3,    10,    10,    69,    93,
      93,    16,    17,    18,    19,    20,     8,    10,    21,    22,
       3,    68,    68,    68,    68,     5,    10,    10,    10,    69,
      69,    69,    69,    69,     9,     6,    93,    93,    10,    10,
      10,    10,    10,    12,     3,    91,    92,     8,     7,     8,
      10,    13,    14,    63,    98,    99,    69,    92,    10,    15,
       3,   100,     8,     6,    99,     8,    64,     3,     4,     5,
       9,    13,    31,   101,   102,   103,   104,     3,    29,    29,
      29,    69,     3,     4,     5,     9,     8,    21,    16,    17,
      18,    30,    31,     3,     3,     3,    10,    29,    29,    29,
      69,    13,    63,   105,   101,    69,    69,    69,   104,   104,
      29,     3,     3,     3,    10,     3,   106,   107,    10,     3,
      29,    11,    16,     8,    64,     6,     3,    68,     3,     4,
       5,     9,    31,    33,    34,    35,    70,   107,    12,    11,
      70,    70,     9,     9,     9,    28,    29,    30,    31,    32,
      16,    68,    71,    10,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    12,    12,    10,     8,     8,    70,    70,
      10,    10
  };

  const unsigned char
  Lha_parser::yyr1_[] =
  {
       0,    65,    66,    66,    66,    66,    67,    67,    67,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    71,    71,    72,    72,    72,    72,    72,
      73,    73,    74,    74,    75,    76,    77,    77,    78,    79,
      79,    79,    79,    79,    79,    80,    81,    81,    82,    82,
      83,    84,    84,    85,    86,    86,    87,    87,    88,    89,
      89,    90,    90,    91,    91,    92,    93,    93,    93,    93,
      93,    93,    93,    94,    94,    94,    94,    94,    95,    96,
      96,    97,    98,    98,    98,    98,    99,   100,   100,   101,
     101,   101,   102,   102,   102,   103,   103,   103,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   105,   105,
     106,   106,   107,   107,   108,   108,   109,   109,   110,   110,
     110,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   113,
     113,   113,   113,   113,   114,   114,   114,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115
  };

  const unsigned char
  Lha_parser::yyr2_[] =
  {
       0,     2,     0,     4,     3,     1,     0,     4,     3,     1,
       1,     4,     4,     3,     2,     3,     3,     3,     3,     4,
       6,     6,     6,     6,     1,     1,     1,     4,     3,     2,
       3,     3,     3,     3,     3,     4,     6,     6,     1,     1,
       1,     4,     4,     3,     2,     3,     3,     3,     3,     3,
       4,     6,     6,     2,     3,     2,     2,     1,     1,     0,
       1,     2,     6,     6,     4,     4,     2,     2,     6,     1,
       2,     5,     3,     4,     7,     6,     1,     3,     2,     2,
       6,     1,     3,     6,     1,     3,     2,     2,     6,     1,
       2,    10,     6,     1,     3,     3,     1,     1,     1,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     6,     1,
       2,    14,     1,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     3,     3,     1,     3,     3,     1,     5,
       3,     3,     3,     2,     6,     4,     4,     4,     3,     1,
       1,     3,     3,     6,     1,     2,     4,     2,     1,     1,
       1,     4,     1,     3,     4,     1,     1,     6,    10,    10,
       4,     3,     3,     3,     3,     3,     1,     1,     1,     6,
       6,     2,     4,     3,     3,     3,     3,     3,     3,     4,
       4,     4,     4,     4,     1,     3,     3,     1,     4,     5,
       3,     3,     1,     1,     3,     2,     6,     4,     4,     4
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const Lha_parser::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "str", "rval", "ival",
  "SEMICOLON", "COLON", "COMMA", "LB", "RB", "LSB", "RSB", "SHARP", "ALL",
  "BackSlash", "EQ", "GEQ", "LEQ", "LL", "GG", "AND", "OR", "NOT", "TRUE",
  "FALSE", "DOUBLE", "INT", "DIV", "MUL", "PLUS", "MINUS", "POWER",
  "FLOOR", "MIN", "MAX", "MOD", "LhaMIN", "LhaMAX", "AVG", "VAR", "PROB",
  "SPRT", "LAST", "INTEGRAL", "MEAN", "DISC", "NOTDET", "LhaName", "Const",
  "NbLoc", "NbVar", "VList", "LList", "Iloc", "Floc", "locations", "edges",
  "PDF", "CDF", "EXIST_TOK", "NOTALL_TOK", "NEG", "'{'", "'}'", "$accept",
  "LHA", "declarations", "IntMarkingFormula", "RealMarkingFormula",
  "RealVarMarkingFormula", "ColorClassList", "Sizes", "Constants",
  "Constant", "NbVariables", "NbLocations", "Lists", "VariablesList",
  "VLabels", "LocationsList", "LLabels", "InitFinal", "init", "iLLabels",
  "final", "fLLabels", "definitions", "LocationsDef", "LOCATIONS",
  "LOCATION", "FLOWS", "FLOW", "LogExpr", "CompExpr", "EdgesDef", "EDGES",
  "EDGE", "ACTIONS", "SetOfActions", "Actions", "CONSTRAINTS",
  "CONSTRAINT", "LinearExp", "term", "UPDATES", "Updates", "Update",
  "HaslExps", "HaslExp", "rorival", "TopHaslExp", "AlgExpr", "LhaFunc",
  "LinForm", "VarTerm", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
  Lha_parser::yyrline_[] =
  {
       0,   188,   188,   189,   190,   191,   193,   194,   195,   201,
     202,   217,   224,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   244,   245,   246,   258,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   276,   277,
     278,   297,   304,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   322,   323,   325,   326,   327,   328,   329,
     331,   332,   334,   343,   354,   356,   358,   359,   361,   377,
     385,   395,   406,   414,   422,   431,   441,   445,   450,   451,
     453,   455,   463,   468,   470,   478,   487,   488,   492,   502,
     503,   505,   516,   530,   531,   532,   539,   540,   541,   542,
     543,   544,   545,   547,   548,   549,   550,   551,   556,   560,
     561,   563,   588,   589,   590,   594,   596,   598,   602,   607,
     608,   609,   611,   616,   621,   627,   628,   629,   631,   635,
     640,   645,   650,   671,   675,   680,   685,   690,   713,   719,
     724,   725,   727,   732,   744,   744,   746,   757,   770,   771,
     772,   782,   786,   789,   792,   796,   799,   802,   805,   820,
     835,   846,   849,   852,   855,   858,   861,   864,   868,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,   882,
     892,   902,   912,   922,   933,   934,   935,   937,   946,   953,
     958,   963,   969,   972,   975,   994,   998,  1003,  1008,  1013
  };

  // Print the state stack on the debug stream.
  void
  Lha_parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Lha_parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  inline
  Lha_parser::token_number_type
  Lha_parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    63,     2,    64,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62
    };
    const unsigned int user_token_number_max_ = 317;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }


} // lha
#line 3025 "Lha-parser.cc" // lalr1.cc:1167
#line 1037 "Lha-parser.yy" // lalr1.cc:1168


void
lha::Lha_parser::error (const lha::Lha_parser::location_type& l,
const std::string& m)
{
	Reader.error (l, m);
}
